
addHook("PlayerThink", function(p)
if srb2p return end
		if p.mo.skin == SUNK_SKIN
		and (p.mo.state == S_PLAY_JUMP)
		and p.cmd.buttons & BT_CUSTOM1
		p.bouncing = true
	end
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid and p.bouncing == true
		p.mo.state = S_PLAY_FLY
	end
	if p.bouncing == true
	and not (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG or p.mo.eflags & MFE_GOOWATER)
		P_SetObjectMomZ(p.mo, -40*FRACUNIT)
	end
	if p.bouncing
	and (p.mo.eflags & MFE_GOOWATER)
		p.bouncing = false
		p.mo.state = S_PLAY_FALL
	end
end)
						
addHook("PlayerThink", function(p)
	if p.mo.skin == SUNK_SKIN
	and p.bouncing
	and (p.mo.eflags & MFE_JUSTHITFLOOR)
	and not (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
		P_NukeEnemies(p.mo, p.mo, 1000*FRACUNIT)
		S_StartSound(p.mo, sfx_sugp)
		p.mo.state = S_PLAY_JUMP
		p.pflags = $|PF_JUMPED
		p.bouncing = false
	end
	if (p.pflags & PF_JUMPED)
		p.pflags = $ & ~PF_SPINNING
	end
end)


addHook("PlayerThink", function(p)
	if p.mo.skin == SUNK_SKIN
	and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
	and (p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL)
		p.springed = true
	elseif P_IsObjectOnGround(p.mo)
		p.springed = false
	end
	if p.bouncing 
	and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
	and not p.powers[pw_underwater]
		p.bouncing = false
		S_StopSoundByID(p.mo, sfx_spring)
		S_StartSound(p.mo, sfx_sprong)
		p.mo.momz = $*5/4
	end
	if p.bouncing 
	and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
	and p.powers[pw_underwater]
		p.bouncing = false
		S_StopSoundByID(p.mo, sfx_spring)
		S_StartSound(p.mo, sfx_sprong)
		p.mo.momz = $*5/4
	end
end)